Index: uspace/lib/ui/src/slider.c
===================================================================
--- uspace/lib/ui/src/slider.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/ui/src/slider.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,484 @@
+/*
+ * Copyright (c) 2021 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Slider
+ */
+
+#include <errno.h>
+#include <gfx/color.h>
+#include <gfx/context.h>
+#include <gfx/render.h>
+#include <io/pos_event.h>
+#include <stdlib.h>
+#include <str.h>
+#include <ui/control.h>
+#include <ui/paint.h>
+#include <ui/slider.h>
+#include "../private/resource.h"
+#include "../private/slider.h"
+
+/*
+ * The kind reader will appreciate that slider button dimensions 23:15
+ * are chosen such that, after subtracting the frame width (2 times 1),
+ * we get 21:13, which is a good approximation of the golden ratio.
+ */
+enum {
+	/** Slider button width */
+	ui_slider_btn_w = 15,
+	/** Slider button height */
+	ui_slider_btn_h = 23,
+	/** Slider button frame thickness */
+	ui_slider_btn_frame_thickness = 1,
+	/** Slider button bevel width */
+	ui_slider_btn_bevel_width = 2,
+	/** Slider groove width (total) */
+	ui_slider_groove_width = 4,
+	/** Amount by which slider groove bevel extendeds on each side
+	 * beyond nominal groove length.
+	 */
+	ui_slider_groove_margin = 2
+};
+
+static void ui_slider_ctl_destroy(void *);
+static errno_t ui_slider_ctl_paint(void *);
+static ui_evclaim_t ui_slider_ctl_pos_event(void *, pos_event_t *);
+
+/** Slider control ops */
+ui_control_ops_t ui_slider_ops = {
+	.destroy = ui_slider_ctl_destroy,
+	.paint = ui_slider_ctl_paint,
+	.pos_event = ui_slider_ctl_pos_event
+};
+
+/** Create new slider.
+ *
+ * @param resource UI resource
+ * @param caption Caption
+ * @param rslider Place to store pointer to new slider
+ * @return EOK on success, ENOMEM if out of memory
+ */
+errno_t ui_slider_create(ui_resource_t *resource, const char *caption,
+    ui_slider_t **rslider)
+{
+	ui_slider_t *slider;
+	errno_t rc;
+
+	slider = calloc(1, sizeof(ui_slider_t));
+	if (slider == NULL)
+		return ENOMEM;
+
+	rc = ui_control_new(&ui_slider_ops, (void *) slider,
+	    &slider->control);
+	if (rc != EOK) {
+		free(slider);
+		return rc;
+	}
+
+	slider->res = resource;
+	*rslider = slider;
+	return EOK;
+}
+
+/** Destroy slider.
+ *
+ * @param slider Slider or @c NULL
+ */
+void ui_slider_destroy(ui_slider_t *slider)
+{
+	if (slider == NULL)
+		return;
+
+	ui_control_delete(slider->control);
+	free(slider);
+}
+
+/** Get base control from slider.
+ *
+ * @param slider Slider
+ * @return Control
+ */
+ui_control_t *ui_slider_ctl(ui_slider_t *slider)
+{
+	return slider->control;
+}
+
+/** Set slider callbacks.
+ *
+ * @param slider Slider
+ * @param cb Slider callbacks
+ * @param arg Callback argument
+ */
+void ui_slider_set_cb(ui_slider_t *slider, ui_slider_cb_t *cb, void *arg)
+{
+	slider->cb = cb;
+	slider->arg = arg;
+}
+
+/** Set slider rectangle.
+ *
+ * @param slider Slider
+ * @param rect New slider rectangle
+ */
+void ui_slider_set_rect(ui_slider_t *slider, gfx_rect_t *rect)
+{
+	slider->rect = *rect;
+}
+
+/** Paint outer slider frame.
+ *
+ * @param slider Slider
+ * @return EOK on success or an error code
+ */
+static errno_t ui_slider_paint_frame(ui_resource_t *res, gfx_rect_t *rect,
+    gfx_coord_t thickness, gfx_rect_t *inside)
+{
+	gfx_rect_t drect;
+	errno_t rc;
+
+	rc = gfx_set_color(res->gc, res->btn_frame_color);
+	if (rc != EOK)
+		goto error;
+
+	drect.p0.x = rect->p0.x + 1;
+	drect.p0.y = rect->p0.y;
+	drect.p1.x = rect->p1.x - 1;
+	drect.p1.y = rect->p0.y + thickness;
+	rc = gfx_fill_rect(res->gc, &drect);
+	if (rc != EOK)
+		goto error;
+
+	drect.p0.x = rect->p0.x + 1;
+	drect.p0.y = rect->p1.y - thickness;
+	drect.p1.x = rect->p1.x - 1;
+	drect.p1.y = rect->p1.y;
+	rc = gfx_fill_rect(res->gc, &drect);
+	if (rc != EOK)
+		goto error;
+
+	drect.p0.x = rect->p0.x;
+	drect.p0.y = rect->p0.y + 1;
+	drect.p1.x = rect->p0.x + thickness;
+	drect.p1.y = rect->p1.y - 1;
+	rc = gfx_fill_rect(res->gc, &drect);
+	if (rc != EOK)
+		goto error;
+
+	drect.p0.x = rect->p1.x - thickness;
+	drect.p0.y = rect->p0.y + 1;
+	drect.p1.x = rect->p1.x;
+	drect.p1.y = rect->p1.y - 1;
+	rc = gfx_fill_rect(res->gc, &drect);
+	if (rc != EOK)
+		goto error;
+
+	if (inside != NULL) {
+		inside->p0.x = rect->p0.x + thickness;
+		inside->p0.y = rect->p0.y + thickness;
+		inside->p1.x = rect->p1.x - thickness;
+		inside->p1.y = rect->p1.y - thickness;
+	}
+
+	return EOK;
+error:
+	return rc;
+}
+
+/** Paint outset slider bevel.
+ *
+ * @param slider Slider
+ * @return EOK on success or an error code
+ */
+static errno_t ui_slider_paint_outset(ui_slider_t *slider,
+    gfx_rect_t *rect, gfx_rect_t *inside)
+{
+	return ui_paint_bevel(slider->res->gc, rect,
+	    slider->res->btn_highlight_color,
+	    slider->res->btn_shadow_color, ui_slider_btn_bevel_width, inside);
+}
+
+/** Determine slider button rectagle.
+ *
+ * @param slider Slider
+ */
+static void ui_slider_btn_rect(ui_slider_t *slider, gfx_rect_t *rect)
+{
+	gfx_coord2_t pos;
+
+	pos.x = slider->rect.p0.x + slider->pos;
+	pos.y = slider->rect.p0.y;
+
+	rect->p0.x = pos.x;
+	rect->p0.y = pos.y;
+	rect->p1.x = pos.x + ui_slider_btn_w;
+	rect->p1.y = pos.y + ui_slider_btn_h;
+}
+
+/** Determine slider length.
+ *
+ * @param slider Slider
+ * @return Slider length in pixels
+ */
+gfx_coord_t ui_slider_length(ui_slider_t *slider)
+{
+	gfx_coord2_t dims;
+
+	gfx_rect_dims(&slider->rect, &dims);
+	return dims.x - ui_slider_btn_w;
+}
+
+/** Paint slider.
+ *
+ * @param slider Slider
+ * @return EOK on success or an error code
+ */
+errno_t ui_slider_paint(ui_slider_t *slider)
+{
+	gfx_coord2_t pos;
+	gfx_coord_t length;
+	gfx_rect_t rect;
+	gfx_rect_t brect;
+	gfx_rect_t irect;
+	errno_t rc;
+
+	/* Paint slider groove */
+
+	pos = slider->rect.p0;
+	length = ui_slider_length(slider);
+
+	rect.p0.x = pos.x + ui_slider_btn_w / 2 - ui_slider_groove_margin;
+	rect.p0.y = pos.y + ui_slider_btn_h / 2 - ui_slider_groove_width / 2;
+	rect.p1.x = pos.x + ui_slider_btn_w / 2 + length +
+	    ui_slider_groove_margin;
+	rect.p1.y = pos.y + ui_slider_btn_h / 2 + ui_slider_groove_width / 2;
+
+	rc = ui_paint_inset_frame(slider->res, &rect, NULL);
+	if (rc != EOK)
+		goto error;
+
+	/* Paint slider button */
+
+	ui_slider_btn_rect(slider, &rect);
+
+	rc = ui_slider_paint_frame(slider->res, &rect,
+	    ui_slider_btn_frame_thickness, &brect);
+	if (rc != EOK)
+		goto error;
+
+	rc = ui_slider_paint_outset(slider, &brect, &irect);
+	if (rc != EOK)
+		goto error;
+
+	rc = gfx_set_color(slider->res->gc, slider->res->btn_face_color);
+	if (rc != EOK)
+		goto error;
+
+	rc = gfx_fill_rect(slider->res->gc, &irect);
+	if (rc != EOK)
+		goto error;
+
+	rc = gfx_update(slider->res->gc);
+	if (rc != EOK)
+		goto error;
+
+	return EOK;
+error:
+	return rc;
+}
+
+/** Clear slider button.
+ *
+ * @param slider Slider
+ * @return EOK on success or an error code
+ */
+errno_t ui_slider_btn_clear(ui_slider_t *slider)
+{
+	gfx_rect_t rect;
+	errno_t rc;
+
+	ui_slider_btn_rect(slider, &rect);
+
+	rc = gfx_set_color(slider->res->gc, slider->res->wnd_face_color);
+	if (rc != EOK)
+		goto error;
+
+	rc = gfx_fill_rect(slider->res->gc, &rect);
+	if (rc != EOK)
+		goto error;
+
+	return EOK;
+error:
+	return rc;
+}
+
+/** Press down slider.
+ *
+ * @param slider Slider
+ * @param pos Pointer position
+ */
+void ui_slider_press(ui_slider_t *slider, gfx_coord2_t *pos)
+{
+	if (slider->held)
+		return;
+
+	slider->held = true;
+	slider->press_pos = *pos;
+	slider->last_pos = slider->pos;
+
+	(void) ui_slider_paint(slider);
+}
+
+/** Release slider.
+ *
+ * @param slider Slider
+ * @param pos Pointer position
+ */
+void ui_slider_release(ui_slider_t *slider, gfx_coord2_t *pos)
+{
+	if (!slider->held)
+		return;
+
+	ui_slider_update(slider, pos);
+	slider->held = false;
+}
+
+/** Pointer moved.
+ *
+ * @param slider Slider
+ * @param pos New pointer position
+ */
+void ui_slider_update(ui_slider_t *slider, gfx_coord2_t *pos)
+{
+	gfx_coord_t spos;
+	gfx_coord_t length;
+
+	if (slider->held) {
+		spos = slider->last_pos + pos->x - slider->press_pos.x;
+		length = ui_slider_length(slider);
+		if (spos < 0)
+			spos = 0;
+		if (spos > length)
+			spos = length;
+
+		if (spos != slider->pos) {
+			(void) ui_slider_btn_clear(slider);
+			slider->pos = spos;
+			(void) ui_slider_paint(slider);
+			ui_slider_moved(slider, spos);
+		}
+	}
+}
+
+/** Slider was moved.
+ *
+ * @param slider Slider
+ */
+void ui_slider_moved(ui_slider_t *slider, gfx_coord_t pos)
+{
+	if (slider->cb != NULL && slider->cb->moved != NULL)
+		slider->cb->moved(slider, slider->arg, pos);
+}
+
+/** Handle slider position event.
+ *
+ * @param slider Slider
+ * @param pos_event Position event
+ * @return @c ui_claimed iff the event is claimed
+ */
+ui_evclaim_t ui_slider_pos_event(ui_slider_t *slider, pos_event_t *event)
+{
+	gfx_coord2_t pos;
+	gfx_rect_t rect;
+
+	pos.x = event->hpos;
+	pos.y = event->vpos;
+
+	switch (event->type) {
+	case POS_PRESS:
+		ui_slider_btn_rect(slider, &rect);
+		if (gfx_pix_inside_rect(&pos, &rect)) {
+			ui_slider_press(slider, &pos);
+			slider->press_pos = pos;
+			return ui_claimed;
+		}
+		break;
+	case POS_RELEASE:
+		if (slider->held) {
+			ui_slider_release(slider, &pos);
+			return ui_claimed;
+		}
+		break;
+	case POS_UPDATE:
+		ui_slider_update(slider, &pos);
+		break;
+	}
+
+	return ui_unclaimed;
+}
+
+/** Destroy slider control.
+ *
+ * @param arg Argument (ui_slider_t *)
+ */
+void ui_slider_ctl_destroy(void *arg)
+{
+	ui_slider_t *slider = (ui_slider_t *) arg;
+
+	ui_slider_destroy(slider);
+}
+
+/** Paint slider control.
+ *
+ * @param arg Argument (ui_slider_t *)
+ * @return EOK on success or an error code
+ */
+errno_t ui_slider_ctl_paint(void *arg)
+{
+	ui_slider_t *slider = (ui_slider_t *) arg;
+
+	return ui_slider_paint(slider);
+}
+
+/** Handle slider control position event.
+ *
+ * @param arg Argument (ui_slider_t *)
+ * @param pos_event Position event
+ * @return @c ui_claimed iff the event is claimed
+ */
+ui_evclaim_t ui_slider_ctl_pos_event(void *arg, pos_event_t *event)
+{
+	ui_slider_t *slider = (ui_slider_t *) arg;
+
+	return ui_slider_pos_event(slider, event);
+}
+
+/** @}
+ */
Index: uspace/lib/ui/src/ui.c
===================================================================
--- uspace/lib/ui/src/ui.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/ui/src/ui.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -34,11 +34,63 @@
  */
 
+#include <adt/list.h>
+#include <ctype.h>
 #include <display.h>
 #include <errno.h>
 #include <fibril.h>
+#include <io/console.h>
+#include <stdbool.h>
 #include <stdlib.h>
+#include <str.h>
 #include <task.h>
 #include <ui/ui.h>
+#include <ui/wdecor.h>
+#include <ui/window.h>
+#include "../private/window.h"
 #include "../private/ui.h"
+
+/** Parse output specification.
+ *
+ * Output specification has the form <proto>@<service> where proto is
+ * eiher 'disp' for display service or 'cons' for console. Service
+ * is a location ID service name (e.g. hid/display).
+ *
+ * @param ospec Output specification
+ * @param ws Place to store window system type (protocol)
+ * @param osvc Place to store pointer to output service name
+ */
+static void ui_ospec_parse(const char *ospec, ui_winsys_t *ws,
+    const char **osvc)
+{
+	const char *cp;
+
+	if (ospec == UI_DISPLAY_DEFAULT) {
+		*ws = ui_ws_display;
+		*osvc = DISPLAY_DEFAULT;
+		return;
+	}
+
+	cp = ospec;
+	while (isalpha(*cp))
+		++cp;
+
+	if (*cp == '@') {
+		if (str_lcmp(ospec, "disp@", str_length("disp@")) == 0) {
+			*ws = ui_ws_display;
+		} else if (str_lcmp(ospec, "cons@", str_length("cons@")) == 0) {
+			*ws = ui_ws_console;
+		} else {
+			*ws = ui_ws_unknown;
+		}
+
+		if (cp[1] != '\0')
+			*osvc = cp + 1;
+		else
+			*osvc = NULL;
+	} else {
+		*ws = ui_ws_display;
+		*osvc = ospec;
+	}
+}
 
 /** Create new user interface.
@@ -53,17 +105,48 @@
 	errno_t rc;
 	display_t *display;
+	console_ctrl_t *console;
+	console_gc_t *cgc;
+	ui_winsys_t ws;
+	const char *osvc;
 	ui_t *ui;
 
-	rc = display_open(ospec, &display);
-	if (rc != EOK)
-		return rc;
-
-	rc = ui_create_disp(display, &ui);
-	if (rc != EOK) {
-		display_close(display);
-		return rc;
-	}
-
-	ui->display = display;
+	ui_ospec_parse(ospec, &ws, &osvc);
+
+	if (ws == ui_ws_display) {
+		rc = display_open(osvc, &display);
+		if (rc != EOK)
+			return rc;
+
+		rc = ui_create_disp(display, &ui);
+		if (rc != EOK) {
+			display_close(display);
+			return rc;
+		}
+	} else if (ws == ui_ws_console) {
+		console = console_init(stdin, stdout);
+		if (console == NULL)
+			return EIO;
+
+		console_cursor_visibility(console, false);
+
+		/* ws == ui_ws_console */
+		rc = ui_create_cons(console, &ui);
+		if (rc != EOK) {
+			console_done(console);
+			return rc;
+		}
+
+		rc = console_gc_create(console, NULL, &cgc);
+		if (rc != EOK) {
+			ui_destroy(ui);
+			console_done(console);
+			return rc;
+		}
+
+		ui->cgc = cgc;
+	} else {
+		return EINVAL;
+	}
+
 	ui->myoutput = true;
 	*rui = ui;
@@ -71,4 +154,23 @@
 }
 
+/** Create new user interface using console service.
+ *
+ * @param rui Place to store pointer to new UI
+ * @return EOK on success or an error code
+ */
+errno_t ui_create_cons(console_ctrl_t *console, ui_t **rui)
+{
+	ui_t *ui;
+
+	ui = calloc(1, sizeof(ui_t));
+	if (ui == NULL)
+		return ENOMEM;
+
+	ui->console = console;
+	list_initialize(&ui->windows);
+	*rui = ui;
+	return EOK;
+}
+
 /** Create new user interface using display service.
  *
@@ -86,4 +188,5 @@
 
 	ui->display = disp;
+	list_initialize(&ui->windows);
 	*rui = ui;
 	return EOK;
@@ -99,7 +202,38 @@
 		return;
 
-	if (ui->myoutput)
-		display_close(ui->display);
+	if (ui->myoutput) {
+		if (ui->cgc != NULL)
+			console_gc_delete(ui->cgc);
+		if (ui->console != NULL) {
+			console_cursor_visibility(ui->console, true);
+			console_done(ui->console);
+		}
+		if (ui->display != NULL)
+			display_close(ui->display);
+	}
+
 	free(ui);
+}
+
+static void ui_cons_event_process(ui_t *ui, cons_event_t *event)
+{
+	ui_window_t *awnd;
+	ui_evclaim_t claim;
+
+	awnd = ui_window_get_active(ui);
+	if (awnd == NULL)
+		return;
+
+	switch (event->type) {
+	case CEV_KEY:
+		ui_window_send_kbd(awnd, &event->ev.key);
+		break;
+	case CEV_POS:
+		claim = ui_wdecor_pos_event(awnd->wdecor, &event->ev.pos);
+		/* Note: If event is claimed, awnd might not be valid anymore */
+		if (claim == ui_unclaimed)
+			ui_window_send_pos(awnd, &event->ev.pos);
+		break;
+	}
 }
 
@@ -113,8 +247,53 @@
 void ui_run(ui_t *ui)
 {
-	task_retval(0);
-
-	while (!ui->quit)
-		fibril_usleep(100000);
+	cons_event_t event;
+	usec_t timeout;
+	errno_t rc;
+
+	/* Only return command prompt if we are running in a separate window */
+	if (ui->display != NULL)
+		task_retval(0);
+
+	while (!ui->quit) {
+		if (ui->console != NULL) {
+			timeout = 100000;
+			rc = console_get_event_timeout(ui->console,
+			    &event, &timeout);
+
+			/* Do we actually have an event? */
+			if (rc == EOK) {
+				ui_cons_event_process(ui, &event);
+			} else if (rc != ETIMEOUT) {
+				/* Error, quit */
+				break;
+			}
+		} else {
+			fibril_usleep(100000);
+		}
+	}
+}
+
+/** Repaint UI (only used in fullscreen mode).
+ *
+ * This is used when an area is exposed in fullscreen mode.
+ *
+ * @param ui UI
+ * @return @c EOK on success or an error code
+ */
+errno_t ui_paint(ui_t *ui)
+{
+	errno_t rc;
+	ui_window_t *awnd;
+
+	/* XXX Should repaint all windows */
+	awnd = ui_window_get_active(ui);
+	if (awnd == NULL)
+		return EOK;
+
+	rc = ui_wdecor_paint(awnd->wdecor);
+	if (rc != EOK)
+		return rc;
+
+	return ui_window_paint(awnd);
 }
 
@@ -132,4 +311,28 @@
 }
 
+/** Determine if we are running in text mode.
+ *
+ * @param ui User interface
+ * @return @c true iff we are running in text mode
+ */
+bool ui_is_textmode(ui_t *ui)
+{
+	/*
+	 * XXX Currently console is always text and display is always
+	 * graphics, but this need not always be true.
+	 */
+	return (ui->console != NULL);
+}
+
+/** Determine if we are emulating windows.
+ *
+ * @param ui User interface
+ * @return @c true iff we are running in text mode
+ */
+bool ui_is_fullscreen(ui_t *ui)
+{
+	return (ui->display == NULL);
+}
+
 /** @}
  */
Index: uspace/lib/ui/src/wdecor.c
===================================================================
--- uspace/lib/ui/src/wdecor.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/ui/src/wdecor.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -59,5 +59,9 @@
 	wdecor_corner_h = 24,
 	wdecor_edge_w = 4,
-	wdecor_edge_h = 4
+	wdecor_edge_h = 4,
+	wdecor_tbar_h = 22,
+	wdecor_tbar_h_text = 1,
+	wdecor_frame_w = 4,
+	wdecor_frame_w_text = 1
 };
 
@@ -174,21 +178,23 @@
 
 	if ((wdecor->style & ui_wds_frame) != 0) {
-		rc = ui_paint_bevel(wdecor->res->gc, &rect,
-		    wdecor->res->wnd_frame_hi_color,
-		    wdecor->res->wnd_frame_sh_color, 1, &rect);
-		if (rc != EOK)
-			return rc;
-
-		rc = ui_paint_bevel(wdecor->res->gc, &rect,
-		    wdecor->res->wnd_highlight_color,
-		    wdecor->res->wnd_shadow_color, 1, &rect);
-		if (rc != EOK)
-			return rc;
-
-		rc = ui_paint_bevel(wdecor->res->gc, &rect,
-		    wdecor->res->wnd_face_color,
-		    wdecor->res->wnd_face_color, 2, &rect);
-		if (rc != EOK)
-			return rc;
+
+		if (wdecor->res->textmode != false) {
+			rc = ui_paint_bevel(wdecor->res->gc, &rect,
+			    wdecor->res->wnd_frame_hi_color,
+			    wdecor->res->wnd_frame_sh_color, 1, &rect);
+			if (rc != EOK)
+				return rc;
+		} else {
+			rc = ui_paint_outset_frame(wdecor->res, &rect,
+			    &rect);
+			if (rc != EOK)
+				return rc;
+
+			rc = ui_paint_bevel(wdecor->res->gc, &rect,
+			    wdecor->res->wnd_face_color,
+			    wdecor->res->wnd_face_color, 2, &rect);
+			if (rc != EOK)
+				return rc;
+		}
 	}
 
@@ -196,9 +202,11 @@
 		trect = geom.title_bar_rect;
 
-		rc = ui_paint_bevel(wdecor->res->gc, &trect,
-		    wdecor->res->wnd_shadow_color,
-		    wdecor->res->wnd_highlight_color, 1, &trect);
-		if (rc != EOK)
-			return rc;
+		if (wdecor->res->textmode == false) {
+			rc = ui_paint_bevel(wdecor->res->gc, &trect,
+			    wdecor->res->wnd_shadow_color,
+			    wdecor->res->wnd_highlight_color, 1, &trect);
+			if (rc != EOK)
+				return rc;
+		}
 
 		rc = gfx_set_color(wdecor->res->gc, wdecor->active ?
@@ -213,4 +221,7 @@
 
 		gfx_text_fmt_init(&fmt);
+		fmt.color = wdecor->active ?
+		    wdecor->res->tbar_act_text_color :
+		    wdecor->res->tbar_inact_text_color;
 		fmt.halign = gfx_halign_center;
 		fmt.valign = gfx_valign_center;
@@ -218,10 +229,4 @@
 		pos.x = (trect.p0.x + trect.p1.x) / 2;
 		pos.y = (trect.p0.y + trect.p1.y) / 2;
-
-		rc = gfx_set_color(wdecor->res->gc, wdecor->active ?
-		    wdecor->res->tbar_act_text_color :
-		    wdecor->res->tbar_inact_text_color);
-		if (rc != EOK)
-			return rc;
 
 		rc = gfx_puttext(wdecor->res->font, &pos, &fmt, wdecor->caption);
@@ -236,4 +241,8 @@
 	}
 
+	rc = gfx_update(wdecor->res->gc);
+	if (rc != EOK)
+		return rc;
+
 	return EOK;
 }
@@ -291,10 +300,16 @@
 void ui_wdecor_get_geom(ui_wdecor_t *wdecor, ui_wdecor_geom_t *geom)
 {
+	gfx_coord_t frame_w;
+	gfx_coord_t tbar_h;
+
 	/* Does window have a frame? */
 	if ((wdecor->style & ui_wds_frame) != 0) {
-		geom->interior_rect.p0.x = wdecor->rect.p0.x + 4;
-		geom->interior_rect.p0.y = wdecor->rect.p0.y + 4;
-		geom->interior_rect.p1.x = wdecor->rect.p1.x - 4;
-		geom->interior_rect.p1.y = wdecor->rect.p1.y - 4;
+		frame_w = wdecor->res->textmode ?
+		    wdecor_frame_w_text : wdecor_frame_w;
+
+		geom->interior_rect.p0.x = wdecor->rect.p0.x + frame_w;
+		geom->interior_rect.p0.y = wdecor->rect.p0.y + frame_w;
+		geom->interior_rect.p1.x = wdecor->rect.p1.x - frame_w;
+		geom->interior_rect.p1.y = wdecor->rect.p1.y - frame_w;
 	} else {
 		geom->interior_rect = wdecor->rect;
@@ -303,7 +318,10 @@
 	/* Does window have a title bar? */
 	if ((wdecor->style & ui_wds_titlebar) != 0) {
+		tbar_h = wdecor->res->textmode ?
+		    wdecor_tbar_h_text : wdecor_tbar_h;
+
 		geom->title_bar_rect.p0 = geom->interior_rect.p0;
 		geom->title_bar_rect.p1.x = geom->interior_rect.p1.x;
-		geom->title_bar_rect.p1.y = geom->interior_rect.p0.y + 22;
+		geom->title_bar_rect.p1.y = geom->interior_rect.p0.y + tbar_h;
 
 		geom->app_area_rect.p0.x = geom->interior_rect.p0.x;
@@ -321,8 +339,23 @@
 	/* Does window have a close button? */
 	if ((wdecor->style & ui_wds_close_btn) != 0) {
-		geom->btn_close_rect.p0.x = geom->title_bar_rect.p1.x - 1 - 20;
-		geom->btn_close_rect.p0.y = geom->title_bar_rect.p0.y + 1;
-		geom->btn_close_rect.p1.x = geom->title_bar_rect.p1.x - 1;
-		geom->btn_close_rect.p1.y = geom->title_bar_rect.p0.y + 1 + 20;
+		if (wdecor->res->textmode == false) {
+			geom->btn_close_rect.p0.x =
+			    geom->title_bar_rect.p1.x - 1 - 20;
+			geom->btn_close_rect.p0.y =
+			    geom->title_bar_rect.p0.y + 1;
+			geom->btn_close_rect.p1.x =
+			    geom->title_bar_rect.p1.x - 1;
+			geom->btn_close_rect.p1.y =
+			    geom->title_bar_rect.p0.y + 1 + 20;
+		} else {
+			geom->btn_close_rect.p0.x =
+			    geom->title_bar_rect.p1.x - 1 - 3;
+			geom->btn_close_rect.p0.y =
+			    geom->title_bar_rect.p0.y;
+			geom->btn_close_rect.p1.x =
+			    geom->title_bar_rect.p1.x - 1;
+			geom->btn_close_rect.p1.y =
+			    geom->title_bar_rect.p0.y + 1;
+		}
 	} else {
 		geom->btn_close_rect.p0.x = 0;
@@ -523,6 +556,7 @@
  * @param wdecor Window decoration
  * @param pos_event Position event
- */
-void ui_wdecor_pos_event(ui_wdecor_t *wdecor, pos_event_t *event)
+ * @return @c ui_claimed iff event was claimed
+ */
+ui_evclaim_t ui_wdecor_pos_event(ui_wdecor_t *wdecor, pos_event_t *event)
 {
 	gfx_coord2_t pos;
@@ -538,14 +572,18 @@
 		claim = ui_pbutton_pos_event(wdecor->btn_close, event);
 		if (claim == ui_claimed)
-			return;
+			return ui_claimed;
 	}
 
 	ui_wdecor_frame_pos_event(wdecor, event);
 
-	if ((wdecor->style & ui_wds_titlebar) != 0)  {
+	if ((wdecor->style & ui_wds_titlebar) != 0) {
 		if (event->type == POS_PRESS &&
-		    gfx_pix_inside_rect(&pos, &geom.title_bar_rect))
+		    gfx_pix_inside_rect(&pos, &geom.title_bar_rect)) {
 			ui_wdecor_move(wdecor, &pos);
-	}
+			return ui_claimed;
+		}
+	}
+
+	return ui_unclaimed;
 }
 
